﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.WebUI.UltraWebGrid;
using Infragistics.Web.UI;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        UltraWebGrid1.InitializeRow += 
                new InitializeRowEventHandler(UltraWebGrid1_InitializeRow);

        if (!IsPostBack)
        {
            UltraWebGrid1.DataSource = MakeTable();
            UltraWebGrid1.DataBind();
        }
   
    }

void UltraWebGrid1_InitializeRow(object sender, RowEventArgs e)
{
    if (e.Row.IsAlternate())
    {
        TemplatedColumn tColumn = 
            (TemplatedColumn)((UltraWebGrid)sender).Columns.FromKey("ColTemplate");
        tColumn.CellTemplate = new CustomButtonTemplate();
    }
    else
    {
        TemplatedColumn tColumn = 
            (TemplatedColumn)((UltraWebGrid)sender).Columns.FromKey("ColTemplate");
        tColumn.CellTemplate = new CustomCheckBoxTemplate();
    }   
}

    protected void UltraWebGrid1_InitializeLayout(object sender, Infragistics.WebUI.UltraWebGrid.LayoutEventArgs e)
    {
       //layout configuration 
        e.Layout.FrameStyle.Width = Unit.Percentage(100);
        e.Layout.FrameStyle.Height = Unit.Pixel(300);
        UltraWebGrid1.Columns[0].Width = Unit.Percentage(33);
       
        //Create template column after grid binding.

        if (!IsPostBack)
        {
               createTemplateColumn();
        }
     

    }

   

    //Create template column 
    void createTemplateColumn() {
     
        //Create a template column.
        TemplatedColumn col1 = new TemplatedColumn(true) ;
        col1.Header.Caption = "Template column";
       
        //Assign the template control to the template column.
      //  col1.CellTemplate = new CustomItemTemplate();
        col1.Key = "ColTemplate";
        UltraWebGrid1.Columns.Add(col1);
     
    }


    //Retern DataTable object
    private DataTable MakeTable()
    {
        // Create a new DataTable.
        System.Data.DataTable table = new DataTable("Table");
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);

        // Create second column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);

        // Create second column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);


        // Make the ID column the primary key column.
        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;


        // Create three new DataRow objects and add 
        // them to the DataTable
        for (int i = 0; i <= 20; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;
            row["Data"] = "Data " + i;
            table.Rows.Add(row);
        }
        return table;

    }



        //Create button template
        private class CustomButtonTemplate : ITemplate
        {
        //This is the handler for button click Event.
        void buttonClickHandler(object sender, EventArgs args)
        {
            string test = "";
        }

        //Here you can put whatever control you want.
        public void InstantiateIn(Control container)
        {
            Button button = new Button();
            //Create handler for button click
            button.Click += new EventHandler(buttonClickHandler);
            button.Text = "edit";
            container.Controls.Add(button);
        }
        }

        //Create checkbox  template
        private class CustomCheckBoxTemplate : ITemplate
        {
        //Here you can put whatever control you want.
        public void InstantiateIn(Control container)
        {
            CheckBox checkBox = new CheckBox();
            checkBox.Text = "edit";
            container.Controls.Add(checkBox);
        }
        }

}
